"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import luminarycloud._proto.client.simulation_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class SimulationConfig(google.protobuf.message.Message):
    """Represents a simulation config object."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    CREATE_TIME_FIELD_NUMBER: builtins.int
    UPDATE_TIME_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. The unique identifier for the resource."""
    name: builtins.str
    """Required. User specified resource name, does not need to be unique.
    Maximum allowed length is 256 characters.
    """
    @property
    def parameters(self) -> luminarycloud._proto.client.simulation_pb2.SimulationParam:
        """Client params."""
    @property
    def create_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output only. The timestamp when the resource was created."""
    @property
    def update_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output only. The timestamp when the resource was last updated."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        parameters: luminarycloud._proto.client.simulation_pb2.SimulationParam | None = ...,
        create_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        update_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["create_time", b"create_time", "parameters", b"parameters", "update_time", b"update_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["create_time", b"create_time", "id", b"id", "name", b"name", "parameters", b"parameters", "update_time", b"update_time"]) -> None: ...

global___SimulationConfig = SimulationConfig

class CreateSimulationConfigRequest(google.protobuf.message.Message):
    """Request message type for CreateSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROJECT_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. Project id associated with this resource."""
    name: builtins.str
    """Required. User specified resource name, does not need to be unique.
    Maximum allowed length is 256 characters.
    """
    @property
    def parameters(self) -> luminarycloud._proto.client.simulation_pb2.SimulationParam:
        """Client params."""
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
        name: builtins.str = ...,
        parameters: luminarycloud._proto.client.simulation_pb2.SimulationParam | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["parameters", b"parameters"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["name", b"name", "parameters", b"parameters", "project_id", b"project_id"]) -> None: ...

global___CreateSimulationConfigRequest = CreateSimulationConfigRequest

class CreateSimulationConfigResponse(google.protobuf.message.Message):
    """Response message type for CreateSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIMULATION_CONFIG_FIELD_NUMBER: builtins.int
    @property
    def simulation_config(self) -> global___SimulationConfig:
        """Required. The details of the newly created simulation config."""
    def __init__(
        self,
        *,
        simulation_config: global___SimulationConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> None: ...

global___CreateSimulationConfigResponse = CreateSimulationConfigResponse

class ListSimulationConfigsRequest(google.protobuf.message.Message):
    """Request message type for ListSimulationConfigs rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROJECT_ID_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. The ID of the project for which to list simulation configs."""
    @property
    def parameters(self) -> luminarycloud._proto.client.simulation_pb2.SimulationParam:
        """Client params."""
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
        parameters: luminarycloud._proto.client.simulation_pb2.SimulationParam | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["parameters", b"parameters"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["parameters", b"parameters", "project_id", b"project_id"]) -> None: ...

global___ListSimulationConfigsRequest = ListSimulationConfigsRequest

class ListSimulationConfigsResponse(google.protobuf.message.Message):
    """Response message type for ListSimulationConfigs rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIMULATION_CONFIG_FIELD_NUMBER: builtins.int
    @property
    def simulation_config(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SimulationConfig]:
        """Required. The request list of simulation configs."""
    def __init__(
        self,
        *,
        simulation_config: collections.abc.Iterable[global___SimulationConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> None: ...

global___ListSimulationConfigsResponse = ListSimulationConfigsResponse

class GetSimulationConfigRequest(google.protobuf.message.Message):
    """Request message type for GetSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. The unique identifier for the resource."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___GetSimulationConfigRequest = GetSimulationConfigRequest

class GetSimulationConfigResponse(google.protobuf.message.Message):
    """Response message type for GetSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIMULATION_CONFIG_FIELD_NUMBER: builtins.int
    @property
    def simulation_config(self) -> global___SimulationConfig:
        """Required. The requested simulation config."""
    def __init__(
        self,
        *,
        simulation_config: global___SimulationConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> None: ...

global___GetSimulationConfigResponse = GetSimulationConfigResponse

class UpdateSimulationConfigRequest(google.protobuf.message.Message):
    """Request message type for UpdateSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. The unique identifier for the resource."""
    @property
    def parameters(self) -> luminarycloud._proto.client.simulation_pb2.SimulationParam:
        """Client params."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        parameters: luminarycloud._proto.client.simulation_pb2.SimulationParam | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["parameters", b"parameters"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id", "parameters", b"parameters"]) -> None: ...

global___UpdateSimulationConfigRequest = UpdateSimulationConfigRequest

class UpdateSimulationConfigResponse(google.protobuf.message.Message):
    """Response message type for UpdateSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SIMULATION_CONFIG_FIELD_NUMBER: builtins.int
    @property
    def simulation_config(self) -> global___SimulationConfig:
        """Required. The updated simulation config."""
    def __init__(
        self,
        *,
        simulation_config: global___SimulationConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["simulation_config", b"simulation_config"]) -> None: ...

global___UpdateSimulationConfigResponse = UpdateSimulationConfigResponse

class DeleteSimulationConfigRequest(google.protobuf.message.Message):
    """Request message type for DeleteSimulationConfig rpc."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. The unique identifier for the resource."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___DeleteSimulationConfigRequest = DeleteSimulationConfigRequest
