"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import abc
import collections.abc
import grpc
import luminarycloud._proto.geometryservice.geometryservice_pb2

class GeometryServiceStub:
    def __init__(self, channel: grpc.Channel) -> None: ...
    ListGeometries: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.ListGeometriesRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.ListGeometriesReply,
    ]
    """Lists the geometries available in a project."""
    GetGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.GetGeometryRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.GetGeometryReply,
    ]
    """Get details and current features of the specified geometry."""
    SubscribeGeometry: grpc.UnaryStreamMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.SubscribeGeometryRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.SubscribeGeometryReply,
    ]
    """Subscribes the clients to the updates in the geometry state of a give geometry id."""
    ModifyGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.ModifyGeometryRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.ModifyGeometryReply,
    ]
    """Applies a modification to the currently loaded geometry. If the id of the
    modification is found in the state, it overrides the modification and
    replays all the operations.
    """
    CreateGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.CreateGeometryRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.CreateGeometryReply,
    ]
    """Create a new geometry using the URL of a file that already exists in the
    project.
    """
    TesselationUpToModification: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.TessellationUpToModificationRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.TessellationUpToModificationReply,
    ]
    """Returns the tesselation information up to a given active modification ID."""
    LatestTessellation: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.LatestTessellationRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.LatestTessellationReply,
    ]
    """Returns the latest tesselation of the last available version of the
    geometry. The same information will be broadcast through the subscription
    RPC.
    """
    KeepAlive: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.KeepAliveRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.KeepAliveReply,
    ]
    """Keeps the worker alive only if the worker is up and running. Clients can
    use this endpoint to make sure that the worker is not killed while the
    client is not actively using the service.
    """
    Panic: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.geometryservice.geometryservice_pb2.PanicRequest,
        luminarycloud._proto.geometryservice.geometryservice_pb2.PanicReply,
    ]
    """Crashes the service intentionally. Can only be called by staff users and in
    non-production environments.
    """

class GeometryServiceServicer(metaclass=abc.ABCMeta):
    @abc.abstractmethod
    def ListGeometries(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.ListGeometriesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.ListGeometriesReply:
        """Lists the geometries available in a project."""
    @abc.abstractmethod
    def GetGeometry(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.GetGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.GetGeometryReply:
        """Get details and current features of the specified geometry."""
    @abc.abstractmethod
    def SubscribeGeometry(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.SubscribeGeometryRequest,
        context: grpc.ServicerContext,
    ) -> collections.abc.Iterator[luminarycloud._proto.geometryservice.geometryservice_pb2.SubscribeGeometryReply]:
        """Subscribes the clients to the updates in the geometry state of a give geometry id."""
    @abc.abstractmethod
    def ModifyGeometry(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.ModifyGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.ModifyGeometryReply:
        """Applies a modification to the currently loaded geometry. If the id of the
        modification is found in the state, it overrides the modification and
        replays all the operations.
        """
    @abc.abstractmethod
    def CreateGeometry(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.CreateGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.CreateGeometryReply:
        """Create a new geometry using the URL of a file that already exists in the
        project.
        """
    @abc.abstractmethod
    def TesselationUpToModification(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.TessellationUpToModificationRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.TessellationUpToModificationReply:
        """Returns the tesselation information up to a given active modification ID."""
    @abc.abstractmethod
    def LatestTessellation(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.LatestTessellationRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.LatestTessellationReply:
        """Returns the latest tesselation of the last available version of the
        geometry. The same information will be broadcast through the subscription
        RPC.
        """
    @abc.abstractmethod
    def KeepAlive(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.KeepAliveRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.KeepAliveReply:
        """Keeps the worker alive only if the worker is up and running. Clients can
        use this endpoint to make sure that the worker is not killed while the
        client is not actively using the service.
        """
    @abc.abstractmethod
    def Panic(
        self,
        request: luminarycloud._proto.geometryservice.geometryservice_pb2.PanicRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.geometryservice.geometryservice_pb2.PanicReply:
        """Crashes the service intentionally. Can only be called by staff users and in
        non-production environments.
        """

def add_GeometryServiceServicer_to_server(servicer: GeometryServiceServicer, server: grpc.Server) -> None: ...
